'+------------------------------------------------------------------------------------------------------------
'| OPCIONES DE COMPILACIN Y EJECUCIN
'+------------------------------------------------------------------------------------------------------------

Option Explicit
'On Error Resume Next

'+------------------------------------------------------------------------------------------------------------
'| VARIABLES COMUNES
'+------------------------------------------------------------------------------------------------------------

Dim str_Ayuda

Dim obj_Argumentos

Dim str_Fich_Salida
Dim obj_FSO, obj_Fich_Salida

Dim obj_ADSysInfo, str_DNS, str_Domain
Dim obj_WSHNetwork, str_Computer
Dim Path   ' str_Domain  str_Computer

Dim obj_ADODB_Connection, bstrADOQueryString, RootDom, RSObj
Dim FSMOobj,CompNTDS, Computer

Dim str_Maestro_Esquema
Dim str_Maestro_Nombres_Dominio
Dim str_Maestro_RID
Dim str_Maestro_Emulador_PDC
Dim str_Maestro_Infraestructuras

'+------------------------------------------------------------------------------------------------------------
'| PROGRAMA PRINCIPAL | OBTENER DOMINIO Y DC
'+------------------------------------------------------------------------------------------------------------

' Obtencin del DN del Dominio (vlido si el script se ejecuta en una mquina del Dominio)
Set obj_ADSysInfo = CreateObject ("ADSystemInfo")
str_DNS    = obj_ADSysInfo.DomainDNSName
str_Domain = UCase ("DC=" & replace (str_DNS, ".", ",DC="))

' Obtencin del nombre del equipo (vlido si el script se ejecuta en un DC)
Set obj_WSHNetwork = CreateObject ("WScript.Network")
str_Computer = UCase (obj_WSHNetwork.ComputerName)

'+------------------------------------------------------------------------------------------------------------
'| PROGRAMA PRINCIPAL | SOLICITAR DC O DOMINIO
'+------------------------------------------------------------------------------------------------------------

Set obj_Argumentos = WScript.Arguments

str_Ayuda = "USO:" & Chr(13) & Chr(10) &_
            "find_fsmo DC=MYDOM,DC=COM" & Chr(13) & Chr(10) &_
            "find_fsmo DC_NAME"

Select Case obj_Argumentos.Count
   Case 0
      Path = InputBox ("Introduce DN (DC=MYDOM,DC=COM) del dominio o nombre de un DC al que consultar:", "Introduce Path:", str_Domain)
   Case 1
      Select Case UCase (obj_Argumentos (0))
         Case "?"
            WScript.Echo str_Ayuda
            WScript.Quit
         Case "/?"
            WScript.Echo str_Ayuda
            WScript.Quit
         Case "HELP"
            WScript.Echo str_Ayuda
            WScript.Quit
         Case Else
            Path = obj_Argumentos (0)
      End Select
   Case Else
      WScript.Echo str_Ayuda
      WScript.Quit
End Select

'+------------------------------------------------------------------------------------------------------------
'| PROGRAMA PRINCIPAL | CREACIN DEL FICHERO DE SALIDA
'+------------------------------------------------------------------------------------------------------------

str_Fich_Salida = "find_fsmo_roles.html"

Set obj_FSO         = CreateObject ("Scripting.FileSystemObject")
Set obj_Fich_Salida = obj_FSO.CreateTextFile (str_Fich_Salida, True)

'+------------------------------------------------------------------------------------------------------------
'| PROGRAMA PRINCIPAL | INSERCIN EN SALIDA DE CABECERA HTML
'+------------------------------------------------------------------------------------------------------------

obj_Fich_Salida.WriteLine ("<html>")
obj_Fich_Salida.WriteLine ("   <head>")
obj_Fich_Salida.WriteLine ("      <title>FIND FSMO ROLES</title>")
obj_Fich_Salida.WriteLine ("      <h>")
obj_Fich_Salida.WriteLine ("         <strong>FIND FSMO ROLES</strong><br>")
obj_Fich_Salida.WriteLine ("         <strong>Path: " & UCase (Path) & "</strong><br>")
obj_Fich_Salida.WriteLine ("         <strong>" & Now () & "</strong><br>")
obj_Fich_Salida.WriteLine ("      </h>")
obj_Fich_Salida.WriteLine ("   </head>")
obj_Fich_Salida.WriteLine ("   <body>")

obj_Fich_Salida.WriteLine ("      <br>")
obj_Fich_Salida.WriteLine ("      <table border=""1"" cellpadding=""5"" cellspacing=""5"">")
obj_Fich_Salida.WriteLine ("         <tr bgcolor=""999999"">")
obj_Fich_Salida.WriteLine ("            <td><font color=""FFFFFF""><center><strong>AMBITO</strong></center></font></td>")
obj_Fich_Salida.WriteLine ("            <td><font color=""FFFFFF""><center><strong>ROL FSMO</strong></center></font></td>")
obj_Fich_Salida.WriteLine ("            <td><font color=""FFFFFF""><center><strong>PROPIETARIO</strong></center></font></td>")
obj_Fich_Salida.WriteLine ("         </tr>")

'+------------------------------------------------------------------------------------------------------------
'| PROGRAMA PRINCIPAL | CONSULTA DE ROLES FSMO
'+------------------------------------------------------------------------------------------------------------

Set obj_ADODB_Connection = CreateObject ("ADODB.Connection")
obj_ADODB_Connection.Provider = "ADSDSOObject"
obj_ADODB_Connection.Open "ADs Provider"

' Maestro Emulador de PDC
bstrADOQueryString = "<LDAP://"&Path&">;(&(objectClass=domainDNS)(fSMORoleOwner=*));adspath;subtree"
Set RootDom = GetObject("LDAP://RootDSE")
Set RSObj = obj_ADODB_Connection.Execute(bstrADOQueryString)
Set FSMOobj = GetObject(RSObj.Fields(0).Value)
Set CompNTDS = GetObject("LDAP://" & FSMOobj.fSMORoleOwner)
Set Computer = GetObject(CompNTDS.Parent)
str_Maestro_Emulador_PDC = UCase (Computer.dnsHostName)

' Maestro RID
bstrADOQueryString = "<LDAP://"&Path&">;(&(objectClass=rIDManager)(fSMORoleOwner=*));adspath;subtree"
Set RSObj = obj_ADODB_Connection.Execute(bstrADOQueryString)
Set FSMOobj = GetObject(RSObj.Fields(0).Value)
Set CompNTDS = GetObject("LDAP://" & FSMOobj.fSMORoleOwner)
Set Computer = GetObject(CompNTDS.Parent)
str_Maestro_RID = UCase (Computer.dnsHostName)

' Maestro de Infraestructuras
bstrADOQueryString = "<LDAP://"&Path&">;(&(objectClass=infrastructureUpdate)(fSMORoleOwner=*));adspath;subtree"
Set RSObj = obj_ADODB_Connection.Execute(bstrADOQueryString)
Set FSMOobj = GetObject(RSObj.Fields(0).Value)
Set CompNTDS = GetObject("LDAP://" & FSMOobj.fSMORoleOwner)
Set Computer = GetObject(CompNTDS.Parent)
str_Maestro_Infraestructuras = UCase (Computer.dnsHostName)

' Maestro de Esquema
bstrADOQueryString = "<LDAP://"&RootDom.Get("schemaNamingContext")&">;(&(objectClass=dMD)(fSMORoleOwner=*));adspath;subtree"
Set RSObj = obj_ADODB_Connection.Execute(bstrADOQueryString)
Set FSMOobj = GetObject(RSObj.Fields(0).Value)
Set CompNTDS = GetObject("LDAP://" & FSMOobj.fSMORoleOwner)
Set Computer = GetObject(CompNTDS.Parent)
str_Maestro_Esquema = UCase (Computer.dnsHostName)

' Maestro de Nombres de Dominio
bstrADOQueryString = "<LDAP://"&RootDom.Get("configurationNamingContext")&">;(&(objectClass=crossRefContainer)(fSMORoleOwner=*));adspath;subtree"
Set RSObj = obj_ADODB_Connection.Execute(bstrADOQueryString)
Set FSMOobj = GetObject(RSObj.Fields(0).Value)
Set CompNTDS = GetObject("LDAP://" & FSMOobj.fSMORoleOwner)
Set Computer = GetObject(CompNTDS.Parent)
str_Maestro_Nombres_Dominio = UCase (Computer.dnsHostName)

'+------------------------------------------------------------------------------------------------------------
'| PROGRAMA PRINCIPAL | INSERCIN EN SALIDA DE ROLES
'+------------------------------------------------------------------------------------------------------------

obj_Fich_Salida.WriteLine ("         <tr>")
obj_Fich_Salida.WriteLine ("            <td bgcolor=""AAAAFF"">BOSQUE</td>")
obj_Fich_Salida.WriteLine ("            <td>Maestro de Esquema</td>")
obj_Fich_Salida.WriteLine ("            <td><center><strong>" & str_Maestro_Esquema & "</strong></center></td>")
obj_Fich_Salida.WriteLine ("         </tr>")
obj_Fich_Salida.WriteLine ("         <tr>")
obj_Fich_Salida.WriteLine ("            <td bgcolor=""AAAAFF"">BOSQUE</td>")
obj_Fich_Salida.WriteLine ("            <td>Maestro de Nombres de Dominio</td>")
obj_Fich_Salida.WriteLine ("            <td><center><strong>" & str_Maestro_Nombres_Dominio & "</strong></center></td>")
obj_Fich_Salida.WriteLine ("         </tr>")
obj_Fich_Salida.WriteLine ("         <tr>")
obj_Fich_Salida.WriteLine ("            <td bgcolor=""AAFFAA"">DOMINIO</td>")
obj_Fich_Salida.WriteLine ("            <td>Maestro RID</strong></center></td>")
obj_Fich_Salida.WriteLine ("            <td><center><strong>" & str_Maestro_RID & "</strong></center></td>")
obj_Fich_Salida.WriteLine ("         </tr>")
obj_Fich_Salida.WriteLine ("         <tr>")
obj_Fich_Salida.WriteLine ("            <td bgcolor=""AAFFAA"">DOMINIO</td>")
obj_Fich_Salida.WriteLine ("            <td>Maestro Emulador de PDC</strong></center></td>")
obj_Fich_Salida.WriteLine ("            <td><center><strong>" & str_Maestro_Emulador_PDC & "</strong></center></td>")
obj_Fich_Salida.WriteLine ("         </tr>")
obj_Fich_Salida.WriteLine ("         <tr>")
obj_Fich_Salida.WriteLine ("            <td bgcolor=""AAFFAA"">DOMINIO</td>")
obj_Fich_Salida.WriteLine ("            <td>Maestro de Infraestructuras</strong></center></td>")
obj_Fich_Salida.WriteLine ("            <td><center><strong>" & str_Maestro_Infraestructuras & "</strong></center></td>")
obj_Fich_Salida.WriteLine ("         </tr>")

'+------------------------------------------------------------------------------------------------------------
'| PROGRAMA PRINCIPAL | INSERCIN EN SALIDA DE PIE HTML
'+------------------------------------------------------------------------------------------------------------

obj_Fich_Salida.WriteLine ("      </table>")

obj_Fich_Salida.WriteLine ("   </body>")
obj_Fich_Salida.WriteLine ("</html>")

'+------------------------------------------------------------------------------------------------------------
'| PROGRAMA PRINCIPAL | CIERRE DE LA SALIDA HTML
'+------------------------------------------------------------------------------------------------------------

Dim wsh_Shell

Set wsh_Shell = WScript.CreateObject ("WScript.Shell")
wsh_Shell.Run "explorer.exe " & wsh_Shell.CurrentDirectory & "\" & str_Fich_Salida

'+------------------------------------------------------------------------------------------------------------
'| PROGRAMA PRINCIPAL | CIERRE DE EJECUCIN
'+------------------------------------------------------------------------------------------------------------

obj_Fich_Salida.Close
obj_FSO = Null
WScript.Quit